Index: /code/branches/consolecommands3/src/libraries/core/ConfigFileManager.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/ConfigFileManager.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/ConfigFileManager.cc	(revision 7219)
@@ -425,4 +425,16 @@
     ////////////////////////
 
+    static const std::string __CC_load_name = "reloadSettings";
+    static const std::string __CC_setFilename_name = "setSettingsFile";
+    static const std::string __CC_config_name = "config";
+    static const std::string __CC_tconfig_name = "tconfig";
+    static const std::string __CC_getConfig_name = "getConfig";
+
+    _SetConsoleCommand(__CC_load_name,            &ConfigFile::load);
+    _SetConsoleCommand(__CC_setFilename_name,     &SettingsConfigFile::setFilename);
+    _SetConsoleCommand(__CC_config_name,          &SettingsConfigFile::config).argumentCompleter(0, autocompletion::settingssections()).argumentCompleter(1, autocompletion::settingsentries()).argumentCompleter(2, autocompletion::settingsvalue());
+    _SetConsoleCommand(__CC_tconfig_name,         &SettingsConfigFile::tconfig).argumentCompleter(0, autocompletion::settingssections()).argumentCompleter(1, autocompletion::settingsentries()).argumentCompleter(2, autocompletion::settingsvalue());
+    _SetConsoleCommand(__CC_getConfig_name,       &SettingsConfigFile::getConfig).argumentCompleter(0, autocompletion::settingssections()).argumentCompleter(1, autocompletion::settingsentries());
+
     SettingsConfigFile* SettingsConfigFile::singletonPtr_s = 0;
 
@@ -430,18 +442,18 @@
         : ConfigFile(filename)
     {
-        ConsoleCommand* command = createConsoleCommand(createFunctor(&ConfigFile::load, this), "reloadSettings");
-        CommandExecutor::addConsoleCommandShortcut(command);
-        command = createConsoleCommand(createFunctor(&SettingsConfigFile::setFilename, this), "setSettingsFile");
-        CommandExecutor::addConsoleCommandShortcut(command);
-        command = createConsoleCommand(createFunctor(&SettingsConfigFile::config, this), "config");
-        CommandExecutor::addConsoleCommandShortcut(command).argumentCompleter(0, autocompletion::settingssections()).argumentCompleter(1, autocompletion::settingsentries()).argumentCompleter(2, autocompletion::settingsvalue());
-        command = createConsoleCommand(createFunctor(&SettingsConfigFile::tconfig, this), "tconfig");
-        CommandExecutor::addConsoleCommandShortcut(command).argumentCompleter(0, autocompletion::settingssections()).argumentCompleter(1, autocompletion::settingsentries()).argumentCompleter(2, autocompletion::settingsvalue());
-        command = createConsoleCommand(createFunctor(&SettingsConfigFile::getConfig, this), "getConfig");
-        CommandExecutor::addConsoleCommandShortcut(command).argumentCompleter(0, autocompletion::settingssections()).argumentCompleter(1, autocompletion::settingsentries());
+        _ModifyConsoleCommand(__CC_load_name).setObject(this);
+        _ModifyConsoleCommand(__CC_setFilename_name).setObject(this);
+        _ModifyConsoleCommand(__CC_config_name).setObject(this);
+        _ModifyConsoleCommand(__CC_tconfig_name).setObject(this);
+        _ModifyConsoleCommand(__CC_getConfig_name).setObject(this);
     }
 
     SettingsConfigFile::~SettingsConfigFile()
     {
+        _ModifyConsoleCommand(__CC_load_name).setObject(0);
+        _ModifyConsoleCommand(__CC_setFilename_name).setObject(0);
+        _ModifyConsoleCommand(__CC_config_name).setObject(0);
+        _ModifyConsoleCommand(__CC_tconfig_name).setObject(0);
+        _ModifyConsoleCommand(__CC_getConfig_name).setObject(0);
     }
 
Index: /code/branches/consolecommands3/src/libraries/core/Core.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/Core.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/Core.cc	(revision 7219)
@@ -66,5 +66,5 @@
 #include "Language.h"
 #include "LuaState.h"
-#include "command/CommandExecutor.h"
+#include "command/ConsoleCommand.h"
 #include "command/IOConsole.h"
 #include "command/TclBind.h"
@@ -88,5 +88,5 @@
         : identifierDestroyer_(Identifier::destroyAllIdentifiers)
         // Cleanup guard for external console commands that don't belong to an Identifier
-        , consoleCommandDestroyer_(CommandExecutor::destroyExternalCommands)
+        , consoleCommandDestroyer_(_ConsoleCommand::destroyAll)
         , bGraphicsLoaded_(false)
         , bStartIOConsole_(true)
Index: /code/branches/consolecommands3/src/libraries/core/CorePrereqs.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/CorePrereqs.h	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/CorePrereqs.h	(revision 7219)
@@ -194,5 +194,5 @@
     class ArgumentCompletionListElement;
     class CommandEvaluation;
-    class ConsoleCommand;
+    class _ConsoleCommand;
     class Executor;
     template <class T>
Index: /code/branches/consolecommands3/src/libraries/core/GUIManager.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/GUIManager.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/GUIManager.cc	(revision 7219)
@@ -71,5 +71,5 @@
     static void key_esc()
         { GUIManager::getInstance().keyESC(); }
-    SetConsoleCommandShortcutExternAlias(key_esc, "keyESC");
+    _SetConsoleCommand("keyESC", &key_esc);
 
     class CEGUILogger : public CEGUI::DefaultLogger
@@ -99,6 +99,6 @@
     GUIManager* GUIManager::singletonPtr_s = 0;
 
-    SetConsoleCommandShortcut(GUIManager, showGUI).accessLevel(AccessLevel::User).defaultValue(1, false).defaultValue(2, true);
-    SetConsoleCommandShortcut(GUIManager, hideGUI).accessLevel(AccessLevel::User);
+    _SetConsoleCommand("showGUI", &GUIManager::showGUI).defaultValue(1, false).defaultValue(2, true);
+    _SetConsoleCommand("hideGUI", &GUIManager::hideGUI);
 
     /**
Index: /code/branches/consolecommands3/src/libraries/core/Game.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/Game.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/Game.cc	(revision 7219)
@@ -57,11 +57,11 @@
     static void stop_game()
         { Game::getInstance().stop(); }
-    SetConsoleCommandShortcutExternAlias(stop_game, "exit");
+    _SetConsoleCommand("exit", &stop_game);
     static void printFPS()
         { COUT(0) << Game::getInstance().getAvgFPS() << std::endl; }
-    SetConsoleCommandShortcutExternAlias(printFPS, "printFPS");
+    _SetConsoleCommand("printFPS", &printFPS);
     static void printTickTime()
         { COUT(0) << Game::getInstance().getAvgTickTime() << std::endl; }
-    SetConsoleCommandShortcutExternAlias(printTickTime, "printTickTime");
+    _SetConsoleCommand("printTickTime", &printTickTime);
 
     std::map<std::string, GameStateInfo> Game::gameStateDeclarations_s;
Index: /code/branches/consolecommands3/src/libraries/core/GraphicsManager.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/GraphicsManager.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/GraphicsManager.cc	(revision 7219)
@@ -65,4 +65,7 @@
 namespace orxonox
 {
+    static const std::string __CC_printScreen_name = "printScreen";
+    _DeclareConsoleCommand(__CC_printScreen_name, &prototype::void__void);
+
     class OgreWindowEventListener : public Ogre::WindowEventListener
     {
@@ -131,5 +134,5 @@
 
         Ogre::WindowEventUtilities::removeWindowEventListener(renderWindow_, ogreWindowEventListener_.get());
-        // TODO: Destroy the console command
+        _ModifyConsoleCommand(__CC_printScreen_name).resetFunction();
 
         // Undeclare the resources
@@ -321,6 +324,5 @@
 
         // add console commands
-        ccPrintScreen_ = createConsoleCommand(createFunctor(&GraphicsManager::printScreen, this), "printScreen");
-        CommandExecutor::addConsoleCommandShortcut(ccPrintScreen_);
+        _ModifyConsoleCommand(__CC_printScreen_name).setFunction(&GraphicsManager::printScreen, this);
     }
 
Index: /code/branches/consolecommands3/src/libraries/core/GraphicsManager.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/GraphicsManager.h	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/GraphicsManager.h	(revision 7219)
@@ -114,7 +114,4 @@
         int                 ogreLogLevelCritical_;     //!< Corresponding Orxonox debug level for LL_CRITICAL
 
-        // console commands
-        ConsoleCommand*     ccPrintScreen_;
-
         static GraphicsManager* singletonPtr_s;        //!< Pointer to the Singleton
     };
Index: /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommandCompilation.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommandCompilation.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommandCompilation.cc	(revision 7219)
@@ -37,16 +37,17 @@
 #include "util/StringUtils.h"
 #include "ConsoleCommand.h"
+#include "CommandExecutor.h"
 
 namespace orxonox
 {
-    SetConsoleCommandShortcutExtern(source).argumentCompleter(0, autocompletion::files());
-    SetConsoleCommandShortcutExtern(echo);
-    SetConsoleCommandShortcutExtern(puts);
+    _SetConsoleCommand("source", source).argumentCompleter(0, autocompletion::files());
+    _SetConsoleCommand("echo", echo);
+    _SetConsoleCommand("puts", puts);
 
-    SetConsoleCommandShortcutExtern(read).argumentCompleter(0, autocompletion::files());
-    SetConsoleCommandShortcutExtern(append).argumentCompleter(0, autocompletion::files());
-    SetConsoleCommandShortcutExtern(write).argumentCompleter(0, autocompletion::files());
+    _SetConsoleCommand("read", read).argumentCompleter(0, autocompletion::files());
+    _SetConsoleCommand("append", append).argumentCompleter(0, autocompletion::files());
+    _SetConsoleCommand("write", write).argumentCompleter(0, autocompletion::files());
 
-    SetConsoleCommandShortcutExtern(calculate);
+    _SetConsoleCommand("calculate", calculate);
 
     void source(const std::string& filename)
Index: /code/branches/consolecommands3/src/libraries/core/command/IRC.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/IRC.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/command/IRC.cc	(revision 7219)
@@ -42,7 +42,7 @@
     static const unsigned int IRC_TCL_THREADID  = 1421421421;
 
-    SetConsoleCommand(IRC, say,  true).accessLevel(AccessLevel::User);
-    SetConsoleCommand(IRC, msg,  false).accessLevel(AccessLevel::User);
-    SetConsoleCommand(IRC, nick, false).accessLevel(AccessLevel::User);
+    _SetConsoleCommand("IRC", "say",  &IRC::say);
+    _SetConsoleCommand("IRC", "msg",  &IRC::msg);
+    _SetConsoleCommand("IRC", "nick", &IRC::nick);
 
     IRC::IRC()
Index: /code/branches/consolecommands3/src/libraries/core/command/Shell.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/Shell.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/command/Shell.cc	(revision 7219)
@@ -40,9 +40,9 @@
 namespace orxonox
 {
-    SetConsoleCommandShortcut(OutputHandler, log);
-    SetConsoleCommandShortcut(OutputHandler, error);
-    SetConsoleCommandShortcut(OutputHandler, warning);
-    SetConsoleCommandShortcut(OutputHandler, info);
-    SetConsoleCommandShortcut(OutputHandler, debug);
+    _SetConsoleCommand("log",     OutputHandler::log    );
+    _SetConsoleCommand("error",   OutputHandler::error  );
+    _SetConsoleCommand("warning", OutputHandler::warning);
+    _SetConsoleCommand("info",    OutputHandler::info   );
+    _SetConsoleCommand("debug",   OutputHandler::debug  );
 
     Shell::Shell(const std::string& consoleName, bool bScrollable)
Index: /code/branches/consolecommands3/src/libraries/core/command/TclBind.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/TclBind.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/command/TclBind.cc	(revision 7219)
@@ -44,6 +44,6 @@
 namespace orxonox
 {
-    SetConsoleCommandShortcut(TclBind, tcl);
-    SetConsoleCommandShortcut(TclBind, bgerror);
+    _SetConsoleCommand("tcl", &TclBind::tcl);
+    _SetConsoleCommand("bgerror", &TclBind::bgerror);
 
     TclBind* TclBind::singletonPtr_s = 0;
Index: /code/branches/consolecommands3/src/libraries/core/command/TclThreadManager.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/TclThreadManager.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/command/TclThreadManager.cc	(revision 7219)
@@ -50,11 +50,11 @@
     const float TCLTHREADMANAGER_MAX_CPU_USAGE = 0.50f;
 
-    SetConsoleCommandShortcutAlias(TclThreadManager, execute, "tclexecute").argumentCompleter(0, autocompletion::tclthreads());
-    SetConsoleCommandShortcutAlias(TclThreadManager, query,   "tclquery"  ).argumentCompleter(0, autocompletion::tclthreads());
-    SetConsoleCommand(TclThreadManager, create,  false);
-    SetConsoleCommand(TclThreadManager, destroy, false).argumentCompleter(0, autocompletion::tclthreads());
-    SetConsoleCommand(TclThreadManager, execute, false).argumentCompleter(0, autocompletion::tclthreads());
-    SetConsoleCommand(TclThreadManager, query,   false).argumentCompleter(0, autocompletion::tclthreads());
-    SetConsoleCommand(TclThreadManager, source,  false).argumentCompleter(0, autocompletion::tclthreads());
+    _SetConsoleCommand("tclexecute", &TclThreadManager::execute).argumentCompleter(0, autocompletion::tclthreads());
+    _SetConsoleCommand("tclquery",   &TclThreadManager::query  ).argumentCompleter(0, autocompletion::tclthreads());
+    _SetConsoleCommand("TclThreadManager", "create",  &TclThreadManager::create);
+    _SetConsoleCommand("TclThreadManager", "destroy", &TclThreadManager::destroy).argumentCompleter(0, autocompletion::tclthreads());
+    _SetConsoleCommand("TclThreadManager", "execute", &TclThreadManager::execute).argumentCompleter(0, autocompletion::tclthreads());
+    _SetConsoleCommand("TclThreadManager", "query",   &TclThreadManager::query  ).argumentCompleter(0, autocompletion::tclthreads());
+    _SetConsoleCommand("TclThreadManager", "source",  &TclThreadManager::source ).argumentCompleter(0, autocompletion::tclthreads());
 
     /**
Index: /code/branches/consolecommands3/src/libraries/core/input/InputManager.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/input/InputManager.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/input/InputManager.cc	(revision 7219)
@@ -62,4 +62,11 @@
     SetCommandLineSwitch(keyboard_no_grab).information("Whether not to exclusively grab the keyboard");
 
+    static const std::string __CC_InputManager_name = "InputManager";
+    static const std::string __CC_calibrate_name = "calibrate";
+    static const std::string __CC_reload_name = "reload";
+
+    _SetConsoleCommand(__CC_InputManager_name, __CC_calibrate_name, &InputManager::calibrate).addShortcut();
+    _SetConsoleCommand(__CC_InputManager_name, __CC_reload_name,    &InputManager::reload   );
+
     // Abuse of this source file for the InputHandler
     InputHandler InputHandler::EMPTY;
@@ -118,8 +125,6 @@
         this->updateActiveStates();
 
-        // calibrate console command
-        this->getIdentifier()->addConsoleCommand(createConsoleCommand(createFunctor(&InputManager::calibrate, this), "calibrate"), true);
-        // reload console command
-        this->getIdentifier()->addConsoleCommand(createConsoleCommand(createFunctor(&InputManager::reload, this), "reload"), false);
+        _ModifyConsoleCommand(__CC_InputManager_name, __CC_calibrate_name).setObject(this);
+        _ModifyConsoleCommand(__CC_InputManager_name, __CC_reload_name).setObject(this);
 
         CCOUT(4) << "Construction complete." << std::endl;
@@ -287,4 +292,8 @@
         if (!(internalState_ & Bad))
             this->destroyDevices();
+
+        // Reset console commands
+        _ModifyConsoleCommand(__CC_InputManager_name, __CC_calibrate_name).setObject(0);
+        _ModifyConsoleCommand(__CC_InputManager_name, __CC_reload_name).setObject(0);
 
         CCOUT(3) << "Destruction complete." << std::endl;
Index: /code/branches/consolecommands3/src/libraries/core/input/KeyBinderManager.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/input/KeyBinderManager.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/input/KeyBinderManager.cc	(revision 7219)
@@ -43,4 +43,14 @@
     ManageScopedSingleton(KeyBinderManager, ScopeID::Graphics, false);
 
+    static const std::string __CC_keybind_name = "keybind";
+    static const std::string __CC_tkeybind_name = "tkeybind";
+    static const std::string __CC_unbind_name = "unbind";
+    static const std::string __CC_tunbind_name = "tunbind";
+
+    _SetConsoleCommand(__CC_keybind_name,  &KeyBinderManager::keybind).defaultValues("");
+    _SetConsoleCommand(__CC_tkeybind_name, &KeyBinderManager::tkeybind).defaultValues("");
+    _SetConsoleCommand(__CC_unbind_name,   &KeyBinderManager::unbind).defaultValues("");
+    _SetConsoleCommand(__CC_tunbind_name,  &KeyBinderManager::tunbind).defaultValues("");
+
     KeyBinderManager::KeyBinderManager()
         : currentBinder_(NULL)
@@ -52,12 +62,8 @@
 
         // keybind console commands
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&KeyBinderManager::keybind,  this), "keybind" ))
-            .defaultValues("");
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&KeyBinderManager::tkeybind, this), "tkeybind"))
-            .defaultValues("");
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&KeyBinderManager::unbind, this), "unbind"))
-            .defaultValues("");
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&KeyBinderManager::tunbind, this), "tunbind"))
-            .defaultValues("");
+        _ModifyConsoleCommand(__CC_keybind_name ).setObject(this);
+        _ModifyConsoleCommand(__CC_tkeybind_name).setObject(this);
+        _ModifyConsoleCommand(__CC_unbind_name  ).setObject(this);
+        _ModifyConsoleCommand(__CC_tunbind_name ).setObject(this);
 
         // Load default key binder
@@ -70,4 +76,10 @@
         for (std::map<std::string, KeyBinder*>::const_iterator it = this->binders_.begin(); it != this->binders_.end(); ++it)
             delete it->second;
+
+        // Reset console commands
+        _ModifyConsoleCommand(__CC_keybind_name ).setObject(0);
+        _ModifyConsoleCommand(__CC_tkeybind_name).setObject(0);
+        _ModifyConsoleCommand(__CC_unbind_name  ).setObject(0);
+        _ModifyConsoleCommand(__CC_tunbind_name ).setObject(0);
     }
 
Index: /code/branches/consolecommands3/src/libraries/core/input/KeyDetector.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/input/KeyDetector.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/input/KeyDetector.cc	(revision 7219)
@@ -38,6 +38,8 @@
 namespace orxonox
 {
-    std::string KeyDetector::callbackCommand_s = "KeyDetectorKeyPressed";
     ManageScopedSingleton(KeyDetector, ScopeID::Graphics, false);
+
+    static const std::string __CC_KeyDetector_callback_name = "KeyDetectorKeyPressed";
+    _DeclareConsoleCommand(__CC_KeyDetector_callback_name, &prototype::void__string);
 
     KeyDetector::KeyDetector()
@@ -46,5 +48,6 @@
         RegisterObject(KeyDetector);
 
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&KeyDetector::callback,  this), callbackCommand_s));
+        _ModifyConsoleCommand(__CC_KeyDetector_callback_name).setFunction(&KeyDetector::callback, this);
+
         this->assignCommands();
 
@@ -59,4 +62,5 @@
         inputState_->setHandler(NULL);
         InputManager::getInstance().destroyState("detector");
+        _ModifyConsoleCommand(__CC_KeyDetector_callback_name).resetFunction();
     }
 
@@ -65,5 +69,5 @@
         // Assign every button/axis the same command, but with its name as argument
         for (std::map<std::string, Button*>::const_iterator it = allButtons_.begin(); it != allButtons_.end(); ++it)
-            it->second->parse(callbackCommand_s + ' ' + it->second->groupName_ + "." + it->second->name_);
+            it->second->parse(__CC_KeyDetector_callback_name + ' ' + it->second->groupName_ + "." + it->second->name_);
     }
 
Index: /code/branches/consolecommands3/src/libraries/core/input/KeyDetector.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/input/KeyDetector.h	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/core/input/KeyDetector.h	(revision 7219)
@@ -57,5 +57,4 @@
         FunctorPtr callbackFunction_;
         InputState* inputState_;
-        static std::string callbackCommand_s;
         static KeyDetector* singletonPtr_s;
     };
Index: /code/branches/consolecommands3/src/libraries/network/Host.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/network/Host.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/network/Host.cc	(revision 7219)
@@ -38,5 +38,8 @@
 namespace orxonox {
 
-  SetConsoleCommandShortcut(Host, Chat);
+  static const std::string __CC_printRTT_name = "printRTT";
+
+  _SetConsoleCommand("chat", &Host::Chat);
+  _SetConsoleCommand(__CC_printRTT_name, &Host::printRTT);
 
   // Host*               Host::instance_=0;
@@ -52,6 +55,5 @@
   //   assert(instance_==0);
     instances_s.push_back(this);
-    this->printRTTCC_ = createConsoleCommand( createFunctor(&Host::printRTT, this), "printRTT" );
-    CommandExecutor::addConsoleCommandShortcut( this->printRTTCC_ );
+    _ModifyConsoleCommand(__CC_printRTT_name).setObject(this);
     this->bIsActive_ = false;
   }
@@ -65,6 +67,5 @@
     assert( std::find( instances_s.begin(), instances_s.end(), this )!=instances_s.end() );
     instances_s.erase(std::find( instances_s.begin(), instances_s.end(), this ));
-    if( this->printRTTCC_ )
-      delete this->printRTTCC_;
+    _ModifyConsoleCommand(__CC_printRTT_name).setObject(0);
   }
 
Index: /code/branches/consolecommands3/src/libraries/network/Host.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/network/Host.h	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/network/Host.h	(revision 7219)
@@ -85,5 +85,4 @@
     bool isActive(){ return bIsActive_; }
   private:
-    ConsoleCommand* printRTTCC_;
     static uint32_t clientID_s;
     static uint32_t shipID_s;
Index: /code/branches/consolecommands3/src/libraries/tools/Timer.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/tools/Timer.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/libraries/tools/Timer.cc	(revision 7219)
@@ -39,6 +39,6 @@
 namespace orxonox
 {
-    SetConsoleCommandShortcutExtern(delay);
-    SetConsoleCommandShortcutExtern(killdelays);
+    _SetConsoleCommand("delay", &delay);
+    _SetConsoleCommand("killdelays", &killdelays);
 
     static std::set<Timer*> delaytimerset;
Index: /code/branches/consolecommands3/src/modules/designtools/ScreenshotManager.cc
===================================================================
--- /code/branches/consolecommands3/src/modules/designtools/ScreenshotManager.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/modules/designtools/ScreenshotManager.cc	(revision 7219)
@@ -20,5 +20,5 @@
 {
     ManageScopedSingleton(ScreenshotManager, ScopeID::Graphics, false);
-    SetConsoleCommandAlias(ScreenshotManager, makeScreenshot_s, "printScreenHD", true);
+    _SetConsoleCommand("printScreenHD", &ScreenshotManager::makeScreenshot_s);
 
     ScreenshotManager::ScreenshotManager()
Index: /code/branches/consolecommands3/src/modules/designtools/SkyboxGenerator.cc
===================================================================
--- /code/branches/consolecommands3/src/modules/designtools/SkyboxGenerator.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/modules/designtools/SkyboxGenerator.cc	(revision 7219)
@@ -50,5 +50,5 @@
 {
 
-    SetConsoleCommand(SkyboxGenerator, createSkybox, true);
+    _SetConsoleCommand("SkyboxGenerator", "createSkybox", &SkyboxGenerator::createSkybox).addShortcut();
 
     ManageScopedSingleton(SkyboxGenerator, ScopeID::Graphics, false);
@@ -79,5 +79,5 @@
             if(!this->captionsRemoved_)
             {
-                CommandExecutor::execute("setGametypeStatus false");
+                CommandExecutor::execute("GametypeStatus displayCaption false");
                 this->captionsRemoved_ = true;
                 return;
@@ -145,5 +145,5 @@
                 takeScreenshot_ = false;
                 CommandExecutor::execute("pause");
-                CommandExecutor::execute("setGametypeStatus true");
+                CommandExecutor::execute("GametypeStatus displayCaption true");
                 this->captionsRemoved_ = false;
             }
Index: /code/branches/consolecommands3/src/modules/objects/triggers/Trigger.cc
===================================================================
--- /code/branches/consolecommands3/src/modules/objects/triggers/Trigger.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/modules/objects/triggers/Trigger.cc	(revision 7219)
@@ -38,5 +38,5 @@
 {
 
-  SetConsoleCommand(Trigger, debugFlares, false).defaultValues(false);
+  _SetConsoleCommand("Trigger", "debugFlares", &Trigger::debugFlares).defaultValues(false);
 
   CreateFactory(Trigger);
Index: /code/branches/consolecommands3/src/modules/overlays/hud/GametypeStatus.cc
===================================================================
--- /code/branches/consolecommands3/src/modules/overlays/hud/GametypeStatus.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/modules/overlays/hud/GametypeStatus.cc	(revision 7219)
@@ -41,6 +41,8 @@
     CreateFactory(GametypeStatus);
 
-    /*static*/ bool GametypeStatus::noCaption_s = false;
-    SetConsoleCommand(GametypeStatus, setGametypeStatus, true);
+    static const std::string __CC_GametypeStatus_name = "GametypeStatus";
+    static const std::string __CC_displayCaption_name = "displayCaption";
+
+    _SetConsoleCommand(__CC_GametypeStatus_name, __CC_displayCaption_name, &GametypeStatus::setDisplayCaption);
 
     GametypeStatus::GametypeStatus(BaseObject* creator) : OverlayText(creator)
@@ -49,8 +51,12 @@
 
         this->owner_ = 0;
+        this->bNoCaption_ = false;
+
+        _ModifyConsoleCommand(__CC_GametypeStatus_name, __CC_displayCaption_name).setObject(this);
     }
 
     GametypeStatus::~GametypeStatus()
     {
+        _ModifyConsoleCommand(__CC_GametypeStatus_name, __CC_displayCaption_name).setObject(0);
     }
 
@@ -64,5 +70,5 @@
             ControllableEntity* ce = this->owner_->getControllableEntity();
 
-            if(GametypeStatus::noCaption_s) // No captions are displayed.
+            if (this->bNoCaption_) // No captions are displayed.
             {
                 this->setCaption("");
@@ -105,7 +111,7 @@
         If true captions are displayed, if false, not.
     */
-    /*static*/ void GametypeStatus::setGametypeStatus(bool bValue)
+    void GametypeStatus::setDisplayCaption(bool bValue)
     {
-        GametypeStatus::noCaption_s = !bValue;
+        this->bNoCaption_ = !bValue;
     }
 
Index: /code/branches/consolecommands3/src/modules/overlays/hud/GametypeStatus.h
===================================================================
--- /code/branches/consolecommands3/src/modules/overlays/hud/GametypeStatus.h	(revision 7218)
+++ /code/branches/consolecommands3/src/modules/overlays/hud/GametypeStatus.h	(revision 7219)
@@ -46,9 +46,9 @@
             virtual void changedOwner();
 
-            static void setGametypeStatus(bool bValue); //!< Toggles whether the gametype status is displayed.
+            void setDisplayCaption(bool bValue); //!< Toggles whether the gametype status is displayed.
 
         private:
             PlayerInfo* owner_;
-            static bool noCaption_s;
+            bool bNoCaption_;
 
     };
Index: /code/branches/consolecommands3/src/orxonox/ChatInputHandler.cc
===================================================================
--- /code/branches/consolecommands3/src/orxonox/ChatInputHandler.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/orxonox/ChatInputHandler.cc	(revision 7219)
@@ -46,8 +46,6 @@
 
   /* add commands to console */
-  SetConsoleCommandAlias( ChatInputHandler, activate_static, "startchat",
-    true );
-  SetConsoleCommandAlias( ChatInputHandler, activate_small_static,
-    "startchat_small", true );
+  _SetConsoleCommand( "startchat", &ChatInputHandler::activate_static );
+  _SetConsoleCommand( "startchat_small", &ChatInputHandler::activate_small_static );
 
   /* constructor */
Index: /code/branches/consolecommands3/src/orxonox/Test.cc
===================================================================
--- /code/branches/consolecommands3/src/orxonox/Test.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/orxonox/Test.cc	(revision 7219)
@@ -38,10 +38,10 @@
     CreateFactory ( Test );
 
-    SetConsoleCommand(Test, printV1, true).accessLevel(AccessLevel::User);
-    SetConsoleCommand(Test, printV2, true).accessLevel(AccessLevel::User);
-    SetConsoleCommand(Test, printV3, true).accessLevel(AccessLevel::User);
-    SetConsoleCommand(Test, printV4, true).accessLevel(AccessLevel::User);
-    SetConsoleCommand(Test, call, true).accessLevel(AccessLevel::User);
-    SetConsoleCommand(Test, call2, true).accessLevel(AccessLevel::User);
+    _SetConsoleCommand("Test", "printV1", &Test::printV1).addShortcut();
+    _SetConsoleCommand("Test", "printV2", &Test::printV2).addShortcut();
+    _SetConsoleCommand("Test", "printV3", &Test::printV3).addShortcut();
+    _SetConsoleCommand("Test", "printV4", &Test::printV4).addShortcut();
+    _SetConsoleCommand("Test", "call",    &Test::call).addShortcut();
+    _SetConsoleCommand("Test", "call2",   &Test::call2).addShortcut();
 
 
Index: /code/branches/consolecommands3/src/orxonox/controllers/ArtificialController.cc
===================================================================
--- /code/branches/consolecommands3/src/orxonox/controllers/ArtificialController.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/orxonox/controllers/ArtificialController.cc	(revision 7219)
@@ -47,9 +47,9 @@
 namespace orxonox
 {
-    SetConsoleCommand(ArtificialController, formationflight, true);
-    SetConsoleCommand(ArtificialController, masteraction, true);
-    SetConsoleCommand(ArtificialController, followme, true);
-    SetConsoleCommand(ArtificialController, passivebehaviour, true);
-    SetConsoleCommand(ArtificialController, formationsize, true);
+    _SetConsoleCommand("ArtificialController", "formationflight",  &ArtificialController::formationflight);
+    _SetConsoleCommand("ArtificialController", "masteraction",     &ArtificialController::masteraction);
+    _SetConsoleCommand("ArtificialController", "followme",         &ArtificialController::followme);
+    _SetConsoleCommand("ArtificialController", "passivebehaviour", &ArtificialController::passivebehaviour);
+    _SetConsoleCommand("ArtificialController", "formationsize",    &ArtificialController::formationsize);
 
     static const unsigned int STANDARD_MAX_FORMATION_SIZE = 7;
Index: /code/branches/consolecommands3/src/orxonox/controllers/HumanController.cc
===================================================================
--- /code/branches/consolecommands3/src/orxonox/controllers/HumanController.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/orxonox/controllers/HumanController.cc	(revision 7219)
@@ -40,24 +40,24 @@
 namespace orxonox
 {
-    SetConsoleCommand(HumanController, moveFrontBack, true).setAsInputCommand();
-    SetConsoleCommand(HumanController, moveRightLeft, true).setAsInputCommand();
-    SetConsoleCommand(HumanController, moveUpDown,    true).setAsInputCommand();
-    SetConsoleCommand(HumanController, rotateYaw,     true).setAsInputCommand();
-    SetConsoleCommand(HumanController, rotatePitch,   true).setAsInputCommand();
-    SetConsoleCommand(HumanController, rotateRoll,    true).setAsInputCommand();
-    SetConsoleCommand(HumanController, fire,          true).keybindMode(KeybindMode::OnHold);
-    SetConsoleCommand(HumanController, reload,        true);
-    SetConsoleCommand(HumanController, boost,         true).keybindMode(KeybindMode::OnHold);
-    SetConsoleCommand(HumanController, greet,         true);
-    SetConsoleCommand(HumanController, switchCamera,  true);
-    SetConsoleCommand(HumanController, mouseLook,     true);
-    SetConsoleCommand(HumanController, suicide,       true);
-    SetConsoleCommand(HumanController, toggleGodMode, true);
-    SetConsoleCommand(HumanController, addBots,       true).defaultValues(1);
-    SetConsoleCommand(HumanController, killBots,      true).defaultValues(0);
-    SetConsoleCommand(HumanController, dropItems,     true);
-    SetConsoleCommand(HumanController, useItem,       true);
-    SetConsoleCommand(HumanController, cycleNavigationFocus,   true);
-    SetConsoleCommand(HumanController, releaseNavigationFocus, true);
+    _SetConsoleCommand("HumanController", "moveFrontBack",          &HumanController::moveFrontBack ).addShortcut().setAsInputCommand();
+    _SetConsoleCommand("HumanController", "moveRightLeft",          &HumanController::moveRightLeft ).addShortcut().setAsInputCommand();
+    _SetConsoleCommand("HumanController", "moveUpDown",             &HumanController::moveUpDown    ).addShortcut().setAsInputCommand();
+    _SetConsoleCommand("HumanController", "rotateYaw",              &HumanController::rotateYaw     ).addShortcut().setAsInputCommand();
+    _SetConsoleCommand("HumanController", "rotatePitch",            &HumanController::rotatePitch   ).addShortcut().setAsInputCommand();
+    _SetConsoleCommand("HumanController", "rotateRoll",             &HumanController::rotateRoll    ).addShortcut().setAsInputCommand();
+    _SetConsoleCommand("HumanController", "fire",                   &HumanController::fire          ).addShortcut().keybindMode(KeybindMode::OnHold);
+    _SetConsoleCommand("HumanController", "reload",                 &HumanController::reload        ).addShortcut();
+    _SetConsoleCommand("HumanController", "boost",                  &HumanController::boost         ).addShortcut().keybindMode(KeybindMode::OnHold);
+    _SetConsoleCommand("HumanController", "greet",                  &HumanController::greet         ).addShortcut();
+    _SetConsoleCommand("HumanController", "switchCamera",           &HumanController::switchCamera  ).addShortcut();
+    _SetConsoleCommand("HumanController", "mouseLook",              &HumanController::mouseLook     ).addShortcut();
+    _SetConsoleCommand("HumanController", "suicide",                &HumanController::suicide       ).addShortcut();
+    _SetConsoleCommand("HumanController", "toggleGodMode",          &HumanController::toggleGodMode ).addShortcut();
+    _SetConsoleCommand("HumanController", "addBots",                &HumanController::addBots       ).addShortcut().defaultValues(1);
+    _SetConsoleCommand("HumanController", "killBots",               &HumanController::killBots      ).addShortcut().defaultValues(0);
+    _SetConsoleCommand("HumanController", "dropItems",              &HumanController::dropItems     ).addShortcut();
+    _SetConsoleCommand("HumanController", "useItem",                &HumanController::useItem       ).addShortcut();
+    _SetConsoleCommand("HumanController", "cycleNavigationFocus",   &HumanController::cycleNavigationFocus).addShortcut();
+    _SetConsoleCommand("HumanController", "releaseNavigationFocus", &HumanController::releaseNavigationFocus).addShortcut();
 
     CreateUnloadableFactory(HumanController);
Index: /code/branches/consolecommands3/src/orxonox/controllers/NewHumanController.cc
===================================================================
--- /code/branches/consolecommands3/src/orxonox/controllers/NewHumanController.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/orxonox/controllers/NewHumanController.cc	(revision 7219)
@@ -49,8 +49,8 @@
 namespace orxonox
 {
-    SetConsoleCommand(NewHumanController, changeMode, false).keybindMode(KeybindMode::OnPress);
-    SetConsoleCommand(NewHumanController, accelerate, false).keybindMode(KeybindMode::OnPress);
-    SetConsoleCommand(NewHumanController, decelerate, false).keybindMode(KeybindMode::OnPress);
-    SetConsoleCommand(NewHumanController, unfire,      true).keybindMode(KeybindMode::OnRelease);
+    _SetConsoleCommand("NewHumanController", "changeMode", &NewHumanController::changeMode).keybindMode(KeybindMode::OnPress);
+    _SetConsoleCommand("NewHumanController", "accelerate", &NewHumanController::accelerate).keybindMode(KeybindMode::OnPress);
+    _SetConsoleCommand("NewHumanController", "decelerate", &NewHumanController::decelerate).keybindMode(KeybindMode::OnPress);
+    _SetConsoleCommand("NewHumanController", "unfire",     &NewHumanController::unfire    ).keybindMode(KeybindMode::OnRelease).addShortcut();
 
     CreateUnloadableFactory(NewHumanController);
Index: /code/branches/consolecommands3/src/orxonox/gamestates/GSMainMenu.cc
===================================================================
--- /code/branches/consolecommands3/src/orxonox/gamestates/GSMainMenu.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/orxonox/gamestates/GSMainMenu.cc	(revision 7219)
@@ -48,4 +48,18 @@
     DeclareGameState(GSMainMenu, "mainMenu", false, true);
 
+    static const std::string __CC_startStandalone_name      = "startGame";
+    static const std::string __CC_startServer_name          = "startServer";
+    static const std::string __CC_startClient_name          = "startClient";
+    static const std::string __CC_startDedicated_name       = "startDedicated";
+    static const std::string __CC_startMainMenu_name        = "startMainMenu";
+    static const std::string __CC_setMainMenuSoundPath_name = "setMMSoundPath";
+
+    _SetConsoleCommand(__CC_startStandalone_name,      &GSMainMenu::startStandalone).deactivate();
+    _SetConsoleCommand(__CC_startServer_name,          &GSMainMenu::startServer    ).deactivate();
+    _SetConsoleCommand(__CC_startClient_name,          &GSMainMenu::startClient    ).deactivate();
+    _SetConsoleCommand(__CC_startDedicated_name,       &GSMainMenu::startDedicated ).deactivate();
+    _SetConsoleCommand(__CC_startMainMenu_name,        &GSMainMenu::startMainMenu  ).deactivate();
+    _SetConsoleCommand(__CC_setMainMenuSoundPath_name, &GSMainMenu::setMainMenuSoundPath);
+
     GSMainMenu::GSMainMenu(const GameStateInfo& info)
         : GameState(info)
@@ -89,12 +103,10 @@
         InputManager::getInstance().enterState("MainMenuHackery");
 
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSMainMenu::startStandalone), "startGame"));
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSMainMenu::startServer), "startServer"));
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSMainMenu::startClient), "startClient"));
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSMainMenu::startDedicated), "startDedicated"));
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSMainMenu::startMainMenu), "startMainMenu"));
-
-        // create command to change sound path
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSMainMenu::setMainMenuSoundPath, this), "setMMSoundPath"));
+        _ModifyConsoleCommand(__CC_startStandalone_name).activate();
+        _ModifyConsoleCommand(__CC_startServer_name    ).activate();
+        _ModifyConsoleCommand(__CC_startClient_name    ).activate();
+        _ModifyConsoleCommand(__CC_startDedicated_name ).activate();
+        _ModifyConsoleCommand(__CC_startMainMenu_name  ).activate();
+        _ModifyConsoleCommand(__CC_setMainMenuSoundPath_name).setObject(this);
 
         KeyBinderManager::getInstance().setToDefault();
@@ -122,4 +134,11 @@
         GUIManager::hideGUI("MainMenu");
         GraphicsManager::getInstance().setCamera(0);
+
+        _ModifyConsoleCommand(__CC_startStandalone_name).deactivate();
+        _ModifyConsoleCommand(__CC_startServer_name    ).deactivate();
+        _ModifyConsoleCommand(__CC_startClient_name    ).deactivate();
+        _ModifyConsoleCommand(__CC_startDedicated_name ).deactivate();
+        _ModifyConsoleCommand(__CC_startMainMenu_name  ).deactivate();
+        _ModifyConsoleCommand(__CC_setMainMenuSoundPath_name).setObject(0);
     }
 
Index: /code/branches/consolecommands3/src/orxonox/gamestates/GSRoot.cc
===================================================================
--- /code/branches/consolecommands3/src/orxonox/gamestates/GSRoot.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/orxonox/gamestates/GSRoot.cc	(revision 7219)
@@ -41,5 +41,11 @@
 {
     DeclareGameState(GSRoot, "root", false, false);
-    SetConsoleCommandShortcut(GSRoot, printObjects);
+
+    static const std::string __CC_setTimeFactor_name = "setTimeFactor";
+    static const std::string __CC_pause_name = "pause";
+
+    _SetConsoleCommand("printObjects", &GSRoot::printObjects);
+    _SetConsoleCommand(__CC_setTimeFactor_name, &GSRoot::setTimeFactor).accessLevel(AccessLevel::Master).defaultValues(1.0);
+    _SetConsoleCommand(__CC_pause_name,         &GSRoot::pause        ).accessLevel(AccessLevel::Master);
 
     registerStaticNetworkFunction(&TimeFactorListener::setTimeFactor);
@@ -76,15 +82,12 @@
         TimeFactorListener::setTimeFactor(1.0f);
 
-        // time factor console command
-        ConsoleCommand* command = createConsoleCommand(createFunctor(&GSRoot::setTimeFactor, this), "setTimeFactor");
-        CommandExecutor::addConsoleCommandShortcut(command).accessLevel(AccessLevel::Offline).defaultValue(0, 1.0);
-
-        // time factor console command
-        command = createConsoleCommand(createFunctor(&GSRoot::pause, this), "pause");
-        CommandExecutor::addConsoleCommandShortcut(command).accessLevel(AccessLevel::Offline);
+        _ModifyConsoleCommand(__CC_setTimeFactor_name).setObject(this);
+        _ModifyConsoleCommand(__CC_pause_name).setObject(this);
     }
 
     void GSRoot::deactivate()
     {
+        _ModifyConsoleCommand(__CC_setTimeFactor_name).setObject(0);
+        _ModifyConsoleCommand(__CC_pause_name).setObject(0);
     }
 
Index: /code/branches/consolecommands3/src/orxonox/gametypes/Gametype.cc
===================================================================
--- /code/branches/consolecommands3/src/orxonox/gametypes/Gametype.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/orxonox/gametypes/Gametype.cc	(revision 7219)
@@ -79,11 +79,4 @@
         else
             this->scoreboard_ = 0;
-
-        /* HACK HACK HACK */
-        this->hackAddBots_ = createConsoleCommand( createFunctor(&Gametype::addBots, this), "hackAddBots");
-        this->hackKillBots_ = createConsoleCommand( createFunctor(&Gametype::killBots, this), "hackKillBots");
-        CommandExecutor::addConsoleCommandShortcut( this->hackAddBots_ );
-        CommandExecutor::addConsoleCommandShortcut( this->hackKillBots_ );
-        /* HACK HACK HACK */
     }
 
@@ -93,8 +86,4 @@
         {
             this->gtinfo_->destroy();
-            if( this->hackAddBots_ )
-                delete this->hackAddBots_;
-            if( this->hackKillBots_ )
-                delete this->hackKillBots_;
         }
     }
Index: /code/branches/consolecommands3/src/orxonox/gametypes/Gametype.h
===================================================================
--- /code/branches/consolecommands3/src/orxonox/gametypes/Gametype.h	(revision 7218)
+++ /code/branches/consolecommands3/src/orxonox/gametypes/Gametype.h	(revision 7219)
@@ -184,9 +184,4 @@
             // Config Values
             std::string scoreboardTemplate_;
-
-            /* HACK HACK HACK */
-            ConsoleCommand* hackAddBots_;
-            ConsoleCommand* hackKillBots_;
-            /* HACK HACK HACK */
     };
 }
Index: /code/branches/consolecommands3/src/orxonox/overlays/InGameConsole.cc
===================================================================
--- /code/branches/consolecommands3/src/orxonox/overlays/InGameConsole.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/orxonox/overlays/InGameConsole.cc	(revision 7219)
@@ -58,6 +58,6 @@
     const float CHAR_WIDTH = 7.45f; // fix this please - determine the char-width dynamically
 
-    SetConsoleCommand(InGameConsole, openConsole, true);
-    SetConsoleCommand(InGameConsole, closeConsole, true);
+    _SetConsoleCommand("InGameConsole", "openConsole", &InGameConsole::openConsole).addShortcut();
+    _SetConsoleCommand("InGameConsole", "closeConsole", &InGameConsole::closeConsole).addShortcut();
 
     ManageScopedSingleton(InGameConsole, ScopeID::Graphics, false);
Index: /code/branches/consolecommands3/src/orxonox/overlays/OrxonoxOverlay.cc
===================================================================
--- /code/branches/consolecommands3/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 7219)
@@ -57,8 +57,8 @@
     std::map<std::string, OrxonoxOverlay*> OrxonoxOverlay::overlays_s;
 
-    SetConsoleCommand(OrxonoxOverlay, scaleOverlay, false).accessLevel(AccessLevel::User);
-    SetConsoleCommand(OrxonoxOverlay, scrollOverlay, false).accessLevel(AccessLevel::User);
-    SetConsoleCommand(OrxonoxOverlay, toggleVisibility, false).accessLevel(AccessLevel::User);
-    SetConsoleCommand(OrxonoxOverlay, rotateOverlay, false).accessLevel(AccessLevel::User);
+    _SetConsoleCommand("OrxonoxOverlay", "scaleOverlay",     &OrxonoxOverlay::scaleOverlay);
+    _SetConsoleCommand("OrxonoxOverlay", "scrollOverlay",    &OrxonoxOverlay::scrollOverlay);
+    _SetConsoleCommand("OrxonoxOverlay", "toggleVisibility", &OrxonoxOverlay::toggleVisibility);
+    _SetConsoleCommand("OrxonoxOverlay", "rotateOverlay",    &OrxonoxOverlay::rotateOverlay);
 
     OrxonoxOverlay::OrxonoxOverlay(BaseObject* creator)
Index: /code/branches/consolecommands3/src/orxonox/overlays/OverlayGroup.cc
===================================================================
--- /code/branches/consolecommands3/src/orxonox/overlays/OverlayGroup.cc	(revision 7218)
+++ /code/branches/consolecommands3/src/orxonox/overlays/OverlayGroup.cc	(revision 7219)
@@ -43,7 +43,7 @@
     CreateFactory(OverlayGroup);
 
-    SetConsoleCommand(OverlayGroup, toggleVisibility, false).accessLevel(AccessLevel::User);
-    SetConsoleCommand(OverlayGroup, scaleGroup, false).accessLevel(AccessLevel::User);
-    SetConsoleCommand(OverlayGroup, scrollGroup, false).accessLevel(AccessLevel::User);
+    _SetConsoleCommand("OverlayGroup", "toggleVisibility", &OverlayGroup::toggleVisibility);
+    _SetConsoleCommand("OverlayGroup", "scaleGroup",       &OverlayGroup::scaleGroup);
+    _SetConsoleCommand("OverlayGroup", "scrollGroup",      &OverlayGroup::scrollGroup);
 
     OverlayGroup::OverlayGroup(BaseObject* creator)
